require File.dirname(__FILE__) + '/../test_helper'

class ItemTest < Test::Unit::TestCase
  fixtures :items

  def test_locking
    Item.transaction do
      item = Item.find(1, :lock => true)
      item.quantity -= 1
      item.save!
    end
  end

  def test_validation
    item = items(:one)
    item.quantity = -1
    assert_raise (ActiveRecord::RecordInvalid) { item.save! }
    assert_equal -1, item.quantity
  end

  def test_transaction
    item1 = Item.find(1)
    assert_equal  1, item1.quantity
    item2 = Item.find(2)
    assert_equal  1, item2.quantity
    begin
      Item.transaction do
        item1.quantity = 0
        item1.save!
        item2.quantity = -1
        item2.save!
      end
    rescue ActiveRecord::RecordInvalid
      #
    end
    assert_equal  0, item1.quantity
    assert_equal -1, item2.quantity
  end
end
